package fr.mael.jiwigo.ui.search;

/**
Copyright (c) 2010, Mael
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
 * Neither the name of jiwigo nor the
   names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Mael BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

* @author mael
* Class that extends a file. Allows to display the files in the tree with only their names (instead
* of their path)
*/
public class File extends java.io.File {

    /**
     * Constructor
     * @param pathname
     */
    public File(String pathname) {
	super(pathname);
    }

    @Override
    public String toString() {
	// TODO Auto-generated method stub
	return this.getName();
    }

    /**
     * This method is overriden to allow listing fr.mael.jiwigo.ui.search.File
     * instead of java.io.Files
     * @see java.io.File#listFiles()
     */
    @Override
    public File[] listFiles() {
	// TODO Auto-generated method stub
	java.io.File files[] = super.listFiles();
	if (files == null) {
	    return new File[0];
	} else {
	    File myFiles[] = new File[files.length];
	    for (int i = 0; i < files.length; i++) {
		myFiles[i] = new File(files[i].getAbsolutePath());
	    }
	    return myFiles;
	}
    }

}
