package fr.mael.jiwigo.ui.search.tree;

import java.awt.Component;

import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import fr.mael.jiwigo.transverse.util.Outil;
import fr.mael.jiwigo.ui.search.File;

/**
Copyright (c) 2010, Mael
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
 * Neither the name of jiwigo nor the
   names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Mael BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

* @author mael
* Cell renderer. Allows to display a specific image for a png or a jpg image
* And allows to display "leaf" folders with a folder gui
*/
public class MyTreeCellRenderer extends DefaultTreeCellRenderer {

    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded,
	    boolean leaf, int row, boolean hasFocus) {

	super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);

	DefaultMutableTreeNode theNode = (DefaultMutableTreeNode) value;
	//only if it's a file : the value can be a string and it's not interesting
	if (theNode.getUserObject() instanceof File) {
	    File file = (File) theNode.getUserObject();
	    //if it's a directory and a leaf, the default icon is overriden with the
	    //"openIcon", which shows to the users that it's a folder. Otherwise it can be confusing
	    //and if it's a png or jpg files (which means everything excepts the folders), specific icons
	    //are setted
	    if (file.isDirectory() && leaf) {
		setIcon(openIcon);
	    } else if (file.isFile() && file.getName().toLowerCase().endsWith(".png")) {
		setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/png.png")));
	    } else if (file.isFile()
		    && (file.getName().toLowerCase().endsWith(".jpg") || file.getName().toLowerCase().endsWith(".jpeg"))) {
		setIcon(new ImageIcon(Outil.getURL("fr/mael/jiwigo/img/jpg.png")));
	    }
	}
	return this;
    }

}